# -*- encoding : utf-8 -*-

class Admin::EventsController < ApplicationController

	before_action :auth_admin
	
	layout "admin"
	


	before_action :find_events

	def index 

	end


	def cible
		
		render :layout => false
		
	end
	
	
	def new
	
		@event = Event.new()

	end


	def edit
	
		@event = Event.find(params[:id])
    
		
	end


	def create
		
		@event = Event.new(event_params)

		
		if @event.save
			flash[:notice] = "L'event à été ajouté avec succès."
			self.find_events
		
		else
			render :action => "new" 

		end

	end


	def update
	
		@event = Event.find(params[:id])
	
  
    if params[:event]
  		if @event.update_attributes(event_params)
  			flash[:notice] = "L'event à été modifié avec succès."
  		else
  			render :action => "edit"
  		end
      
      
    elsif params[:tag_id]
      @event.tag_by_tag_ids(params[:tag_id])
    end
    
  
  
		
	end


	def destroy
	
		@event = Event.find(params[:id])
		@event.destroy

	end
	
	protected
	
	def find_events
		date_regex = /^(0[1-9]|[12][0-9]|3[01])[\/](0[1-9]|1[012])[\/](19|20)\d\d$/i 
		if params[:start] and params[:start] =~ date_regex
			start = Date.parse(params[:start]).beginning_of_day 
			params[:start]= start.strftime('%d/%m/%Y')
		else
			params[:start] = ""
		end
		if params[:stop] and params[:stop] =~ date_regex
			stop = Date.parse(params[:stop]).end_of_day 
			params[:stop]= stop.strftime('%d/%m/%Y')
		 else
		 	params[:stop] = ""
		end
		
		@events = Event.order('start_at DESC')
		@events = @events.after(start) if start
		@events = @events.before(stop) if stop
		per_page = (params[:per_page] and params[:per_page] != "") ? params[:per_page] : 5000
		page = (params[:page] and params[:page] != "") ? params[:page] : 1 
		@events = @events.page(page).per(per_page)

		#@events = Event.order('start_at, stop_at').after(start).before(stop)
	end
	
  private
    def event_params
      params.require(:event).permit(:start_at, :title, :slug, :description, :image_file_id)
      
  
      
      
    end

  
end
